# coding: utf-8


"""
IGNORE:
    Nutanix Files APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path

class AWSConfig(object):

    """AWS configuration for tiering profile.

    :param access_key: (:attr:`access_key`) Access key.
    :type access_key: required
     max=1024 chars
    
    :param secret_key: (:attr:`secret_key`) Secret key.
    :type secret_key: 
     max=1024 chars
    
    :param bucket_name: (:attr:`bucket_name`) Bucket name.
    :type bucket_name: 
     min=3 chars, max=63 chars
    
    :param bucket_location: (:attr:`bucket_location`) Bucket location.
    :type bucket_location: 
     max=2048 chars
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'access_key': 'str',
        'secret_key': 'str',
        'bucket_name': 'str',
        'bucket_location': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'access_key': 'accessKey',
        'secret_key': 'secretKey',
        'bucket_name': 'bucketName',
        'bucket_location': 'bucketLocation',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, access_key=None, secret_key=None, bucket_name=None, bucket_location=None, *args, **kwargs):  # noqa: E501
        self.__access_key = None
        self.__secret_key = None
        self.__bucket_name = None
        self.__bucket_location = None
        self.discriminator = None
        self.__access_key = access_key
        if secret_key is not None:
            self.__secret_key = secret_key
        if bucket_name is not None:
            self.__bucket_name = bucket_name
        if bucket_location is not None:
            self.__bucket_location = bucket_location
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'files.v4.config.AWSConfig'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def access_key(self):
        """
        Access key.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__access_key

    @access_key.setter
    def access_key(self, access_key):
        if access_key is None:
            raise ValueError("Invalid value for `access_key`, must not be `None`")  # noqa: E501
        if access_key is not None and len(access_key) > 1024:
            raise ValueError("Invalid value for `access_key`, length must be less than or equal to `1024`")  # noqa: E501

        self.__access_key = access_key

    @property
    def secret_key(self):
        """
        Secret key.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__secret_key

    @secret_key.setter
    def secret_key(self, secret_key):
        if secret_key is not None and len(secret_key) > 1024:
            raise ValueError("Invalid value for `secret_key`, length must be less than or equal to `1024`")  # noqa: E501

        self.__secret_key = secret_key

    @property
    def bucket_name(self):
        """
        Bucket name.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__bucket_name

    @bucket_name.setter
    def bucket_name(self, bucket_name):
        if bucket_name is not None and len(bucket_name) > 63:
            raise ValueError("Invalid value for `bucket_name`, length must be less than or equal to `63`")  # noqa: E501
        if bucket_name is not None and len(bucket_name) < 3:
            raise ValueError("Invalid value for `bucket_name`, length must be greater than or equal to `3`")  # noqa: E501

        self.__bucket_name = bucket_name

    @property
    def bucket_location(self):
        """
        Bucket location.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__bucket_location

    @bucket_location.setter
    def bucket_location(self, bucket_location):
        if bucket_location is not None and len(bucket_location) > 2048:
            raise ValueError("Invalid value for `bucket_location`, length must be less than or equal to `2048`")  # noqa: E501

        self.__bucket_location = bucket_location

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(AWSConfig, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AWSConfig):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

