# coding: utf-8


"""
IGNORE:
    Nutanix Files APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_files_py_client.models.common.v1.config.IPAddressOrFQDN import IPAddressOrFQDN  # noqa: F401,E501
from ntnx_files_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_files_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501
from ntnx_files_py_client.models.files.v4.config.ConnectionStatus import ConnectionStatus  # noqa: F401,E501

class AntivirusServer(ExternalizableAbstractModel):

    """Antivirus server model.

    :param description: (:attr:`description`) Antivirus server description.
    :type description: 
     max=180 chars
    
    :param address: (:attr:`address`) 
    :type address: required
    
    
    :param port: (:attr:`port`) Antivirus server port.
    :type port: required
    
     min=0, max=65535
    :param connection_status: (:attr:`connection_status`) 
    :type connection_status: 
    
    
    :param partner_service_name: (:attr:`partner_service_name`) Internet Content Adaptation Protocol (ICAP) service name.
    :type partner_service_name: 
     max=2048 chars
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'description': 'str',
        'address': 'common.v1.config.IPAddressOrFQDN',
        'port': 'int',
        'connection_status': 'files.v4.config.ConnectionStatus',
        'partner_service_name': 'str',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'description': 'description',
        'address': 'address',
        'port': 'port',
        'connection_status': 'connectionStatus',
        'partner_service_name': 'partnerServiceName',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, description=None, address=None, port=None, connection_status=None, partner_service_name=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__description = None
        self.__address = None
        self.__port = None
        self.__connection_status = None
        self.__partner_service_name = None
        self.discriminator = None
        if description is not None:
            self.__description = description
        self.__address = address
        self.__port = port
        if connection_status is not None:
            self.__connection_status = connection_status
        if partner_service_name is not None:
            self.__partner_service_name = partner_service_name

    def _initialize_object_type(self):
        return 'files.v4.config.AntivirusServer'

    def _initialize_object_version(self):
        return 'v4.r0'


    @property
    def description(self):
        """
        Antivirus server description.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__description

    @description.setter
    def description(self, description):
        if description is not None and len(description) > 180:
            raise ValueError("Invalid value for `description`, length must be less than or equal to `180`")  # noqa: E501

        self.__description = description

    @property
    def address(self):
        """
        

        :type:
            :class:`~ntnx_files_py_client.models.common.v1.config.IPAddressOrFQDN`
        """  # noqa: E501
        return self.__address

    @address.setter
    def address(self, address):
        if address is None:
            raise ValueError("Invalid value for `address`, must not be `None`")  # noqa: E501

        self.__address = address

    @property
    def port(self):
        """
        Antivirus server port.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__port

    @port.setter
    def port(self, port):
        if port is None:
            raise ValueError("Invalid value for `port`, must not be `None`")  # noqa: E501
        if port is not None and port > 65535:  # noqa: E501
            raise ValueError("Invalid value for `port`, must be a value less than or equal to `65535`")  # noqa: E501
        if port is not None and port < 0:  # noqa: E501
            raise ValueError("Invalid value for `port`, must be a value greater than or equal to `0`")  # noqa: E501

        self.__port = port

    @property
    def connection_status(self):
        """
        

        :type:
            :class:`~ntnx_files_py_client.models.files.v4.config.ConnectionStatus`
        """  # noqa: E501
        return self.__connection_status

    @connection_status.setter
    def connection_status(self, connection_status):

        self.__connection_status = connection_status

    @property
    def partner_service_name(self):
        """
        Internet Content Adaptation Protocol (ICAP) service name.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__partner_service_name

    @partner_service_name.setter
    def partner_service_name(self, partner_service_name):
        if partner_service_name is not None and len(partner_service_name) > 2048:
            raise ValueError("Invalid value for `partner_service_name`, length must be less than or equal to `2048`")  # noqa: E501

        self.__partner_service_name = partner_service_name

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(AntivirusServer, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AntivirusServer):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

