# coding: utf-8


"""
IGNORE:
    Nutanix Files APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path

class AzureConfig(object):

    """Azure configuration for tiering profile.

    :param storage_account_name: (:attr:`storage_account_name`) Storage account name for Azure.
    :type storage_account_name: required
     min=3 chars, max=24 chars
    
    :param storage_account_key: (:attr:`storage_account_key`) Storage account key for Azure.
    :type storage_account_key: 
     max=1024 chars
    
    :param container_name: (:attr:`container_name`) Container name for Azure.
    :type container_name: 
     min=3 chars, max=63 chars
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'storage_account_name': 'str',
        'storage_account_key': 'str',
        'container_name': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'storage_account_name': 'storageAccountName',
        'storage_account_key': 'storageAccountKey',
        'container_name': 'containerName',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, storage_account_name=None, storage_account_key=None, container_name=None, *args, **kwargs):  # noqa: E501
        self.__storage_account_name = None
        self.__storage_account_key = None
        self.__container_name = None
        self.discriminator = None
        self.__storage_account_name = storage_account_name
        if storage_account_key is not None:
            self.__storage_account_key = storage_account_key
        if container_name is not None:
            self.__container_name = container_name
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'files.v4.config.AzureConfig'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def storage_account_name(self):
        """
        Storage account name for Azure.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__storage_account_name

    @storage_account_name.setter
    def storage_account_name(self, storage_account_name):
        if storage_account_name is None:
            raise ValueError("Invalid value for `storage_account_name`, must not be `None`")  # noqa: E501
        if storage_account_name is not None and len(storage_account_name) > 24:
            raise ValueError("Invalid value for `storage_account_name`, length must be less than or equal to `24`")  # noqa: E501
        if storage_account_name is not None and len(storage_account_name) < 3:
            raise ValueError("Invalid value for `storage_account_name`, length must be greater than or equal to `3`")  # noqa: E501

        self.__storage_account_name = storage_account_name

    @property
    def storage_account_key(self):
        """
        Storage account key for Azure.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__storage_account_key

    @storage_account_key.setter
    def storage_account_key(self, storage_account_key):
        if storage_account_key is not None and len(storage_account_key) > 1024:
            raise ValueError("Invalid value for `storage_account_key`, length must be less than or equal to `1024`")  # noqa: E501

        self.__storage_account_key = storage_account_key

    @property
    def container_name(self):
        """
        Container name for Azure.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__container_name

    @container_name.setter
    def container_name(self, container_name):
        if container_name is not None and len(container_name) > 63:
            raise ValueError("Invalid value for `container_name`, length must be less than or equal to `63`")  # noqa: E501
        if container_name is not None and len(container_name) < 3:
            raise ValueError("Invalid value for `container_name`, length must be greater than or equal to `3`")  # noqa: E501

        self.__container_name = container_name

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(AzureConfig, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AzureConfig):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

