# coding: utf-8


"""
IGNORE:
    Nutanix Files APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_files_py_client.models.common.v1.config.IPAddressOrFQDN import IPAddressOrFQDN  # noqa: F401,E501
from ntnx_files_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_files_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501

class DnsRecord(ExternalizableAbstractModel):

    """DNS detail for the file server.

    :param host_address: (:attr:`host_address`) 
    :type host_address: 
    
    
    :param ptr_record: (:attr:`ptr_record`) 
    :type ptr_record: 
    
    
    :param is_verified: (:attr:`is_verified`) This field indicates if the DNS entries are verified on the DNS server or not. This is a read-only field.
    :type is_verified: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'host_address': 'common.v1.config.IPAddressOrFQDN',
        'ptr_record': 'common.v1.config.IPAddressOrFQDN',
        'is_verified': 'bool',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'host_address': 'hostAddress',
        'ptr_record': 'ptrRecord',
        'is_verified': 'isVerified',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, host_address=None, ptr_record=None, is_verified=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__host_address = None
        self.__ptr_record = None
        self.__is_verified = None
        self.discriminator = None
        if host_address is not None:
            self.__host_address = host_address
        if ptr_record is not None:
            self.__ptr_record = ptr_record
        if is_verified is not None:
            self.__is_verified = is_verified

    def _initialize_object_type(self):
        return 'files.v4.config.DnsRecord'

    def _initialize_object_version(self):
        return 'v4.r0'


    @property
    def host_address(self):
        """
        

        :type:
            :class:`~ntnx_files_py_client.models.common.v1.config.IPAddressOrFQDN`
        """  # noqa: E501
        return self.__host_address

    @host_address.setter
    def host_address(self, host_address):

        self.__host_address = host_address

    @property
    def ptr_record(self):
        """
        

        :type:
            :class:`~ntnx_files_py_client.models.common.v1.config.IPAddressOrFQDN`
        """  # noqa: E501
        return self.__ptr_record

    @ptr_record.setter
    def ptr_record(self, ptr_record):

        self.__ptr_record = ptr_record

    @property
    def is_verified(self):
        """
        This field indicates if the DNS entries are verified on the DNS server or not. This is a read-only field.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_verified

    @is_verified.setter
    def is_verified(self, is_verified):

        self.__is_verified = is_verified

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(DnsRecord, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DnsRecord):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

