# coding: utf-8


"""
IGNORE:
    Nutanix Files APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path

class FilesSpec(object):

    """Request body specification for tier APIs.

    :param is_single_dir_tree: (:attr:`is_single_dir_tree`) Boolean field to indicate if all files belong to the same VG. (**Default** False)
    :type is_single_dir_tree: 
    
    
    :param mount_target_ext_id: (:attr:`mount_target_ext_id`) Mount target external identifier for files to tier/recall.
    :type mount_target_ext_id: required
    
    
    :param file_paths: (:attr:`file_paths`) Path of the files to be tiered/recalled relative to root Mount target.
    :type file_paths: 
    
    
    :param i_node_numbers: (:attr:`i_node_numbers`) List of inode numbers strings. Inode number should be in the format Inode/Inode:GenId.
    :type i_node_numbers: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'is_single_dir_tree': 'bool',
        'mount_target_ext_id': 'str',
        'file_paths': 'list[str]',
        'i_node_numbers': 'list[str]',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'is_single_dir_tree': 'isSingleDirTree',
        'mount_target_ext_id': 'mountTargetExtId',
        'file_paths': 'filePaths',
        'i_node_numbers': 'iNodeNumbers',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, is_single_dir_tree=False, mount_target_ext_id=None, file_paths=None, i_node_numbers=None, *args, **kwargs):  # noqa: E501
        self.__is_single_dir_tree = None
        self.__mount_target_ext_id = None
        self.__file_paths = None
        self.__i_node_numbers = None
        self.discriminator = None
        if is_single_dir_tree is not None:
            self.__is_single_dir_tree = is_single_dir_tree
        self.__mount_target_ext_id = mount_target_ext_id
        if file_paths is not None:
            self.__file_paths = file_paths
        if i_node_numbers is not None:
            self.__i_node_numbers = i_node_numbers
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'files.v4.config.FilesSpec'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def is_single_dir_tree(self):
        """
        Boolean field to indicate if all files belong to the same VG.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_single_dir_tree

    @is_single_dir_tree.setter
    def is_single_dir_tree(self, is_single_dir_tree):

        self.__is_single_dir_tree = is_single_dir_tree

    @property
    def mount_target_ext_id(self):
        """
        Mount target external identifier for files to tier/recall.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__mount_target_ext_id

    @mount_target_ext_id.setter
    def mount_target_ext_id(self, mount_target_ext_id):
        if mount_target_ext_id is None:
            raise ValueError("Invalid value for `mount_target_ext_id`, must not be `None`")  # noqa: E501
        if mount_target_ext_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', mount_target_ext_id):  # noqa: E501
            raise ValueError(r"Invalid value for `mount_target_ext_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__mount_target_ext_id = mount_target_ext_id

    @property
    def file_paths(self):
        """
        Path of the files to be tiered/recalled relative to root Mount target.

        :type:
            list[ :class:`~str` ]
        """  # noqa: E501
        return self.__file_paths

    @file_paths.setter
    def file_paths(self, file_paths):

        self.__file_paths = file_paths

    @property
    def i_node_numbers(self):
        """
        List of inode numbers strings. Inode number should be in the format Inode/Inode:GenId.

        :type:
            list[ :class:`~str` ]
        """  # noqa: E501
        return self.__i_node_numbers

    @i_node_numbers.setter
    def i_node_numbers(self, i_node_numbers):

        self.__i_node_numbers = i_node_numbers

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(FilesSpec, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FilesSpec):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

