# coding: utf-8


"""
IGNORE:
    Nutanix Files APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_files_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_files_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501

class MigrationPlan(ExternalizableAbstractModel):

    """Migration plan details

    :param name: (:attr:`name`) Migration plan name
    :type name: required
     min=1 chars, max=30 chars
    
    :param source_ext_id: (:attr:`source_ext_id`) The extId of migration source to use for migration.
    :type source_ext_id: required
    
    
    :param sub_plan_ext_ids: (:attr:`sub_plan_ext_ids`) List of sub-plan extIds. This is a read-only field.
    :type sub_plan_ext_ids: 
    
    
    :param description: (:attr:`description`) Description of migration plan
    :type description: 
     max=120 chars
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'name': 'str',
        'source_ext_id': 'str',
        'sub_plan_ext_ids': 'list[str]',
        'description': 'str',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'name': 'name',
        'source_ext_id': 'sourceExtId',
        'sub_plan_ext_ids': 'subPlanExtIds',
        'description': 'description',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, name=None, source_ext_id=None, sub_plan_ext_ids=None, description=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__name = None
        self.__source_ext_id = None
        self.__sub_plan_ext_ids = None
        self.__description = None
        self.discriminator = None
        self.__name = name
        self.__source_ext_id = source_ext_id
        if sub_plan_ext_ids is not None:
            self.__sub_plan_ext_ids = sub_plan_ext_ids
        if description is not None:
            self.__description = description

    def _initialize_object_type(self):
        return 'files.v4.config.MigrationPlan'

    def _initialize_object_version(self):
        return 'v4.r0'


    @property
    def name(self):
        """
        Migration plan name

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__name

    @name.setter
    def name(self, name):
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if name is not None and len(name) > 30:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `30`")  # noqa: E501
        if name is not None and len(name) < 1:
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self.__name = name

    @property
    def source_ext_id(self):
        """
        The extId of migration source to use for migration.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__source_ext_id

    @source_ext_id.setter
    def source_ext_id(self, source_ext_id):
        if source_ext_id is None:
            raise ValueError("Invalid value for `source_ext_id`, must not be `None`")  # noqa: E501
        if source_ext_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', source_ext_id):  # noqa: E501
            raise ValueError(r"Invalid value for `source_ext_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__source_ext_id = source_ext_id

    @property
    def sub_plan_ext_ids(self):
        """
        List of sub-plan extIds. This is a read-only field.

        :type:
            list[ :class:`~str` ]
        """  # noqa: E501
        return self.__sub_plan_ext_ids

    @sub_plan_ext_ids.setter
    def sub_plan_ext_ids(self, sub_plan_ext_ids):

        self.__sub_plan_ext_ids = sub_plan_ext_ids

    @property
    def description(self):
        """
        Description of migration plan

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__description

    @description.setter
    def description(self, description):
        if description is not None and len(description) > 120:
            raise ValueError("Invalid value for `description`, length must be less than or equal to `120`")  # noqa: E501

        self.__description = description

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(MigrationPlan, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MigrationPlan):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

