# coding: utf-8


"""
IGNORE:
    Nutanix Files APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_files_py_client.models.common.v1.config.IPAddressOrFQDN import IPAddressOrFQDN  # noqa: F401,E501
from ntnx_files_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_files_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501
from ntnx_files_py_client.models.files.v4.config.Credential import Credential  # noqa: F401,E501

class MigrationSource(ExternalizableAbstractModel):

    """Migration source server details to be used by migration plans.

    :param name: (:attr:`name`) Migration source name
    :type name: required
     min=1 chars, max=30 chars
    
    :param address: (:attr:`address`) 
    :type address: required
    
    
    :param credential: (:attr:`credential`) 
    :type credential: 
    
    
    :param description: (:attr:`description`) Description for migration source
    :type description: 
     max=120 chars
    
    :param should_discover_mount_targets: (:attr:`should_discover_mount_targets`) A flag to indicate if the backend should start mount-target discovery for migration source server. Upon completion of source creation task, list of discovered mount target can be fetched using GET mount-targets API on migration-sources. Note: Credential field is required for SMB mount-targets discovery and `shouldStartDiscoveryDesc` is write only field. (**Default** False)
    :type should_discover_mount_targets: 
    
    
    :param mount_target_ext_ids: (:attr:`mount_target_ext_ids`) List of mount target extIds for migration source server. This is a read-only field.
    :type mount_target_ext_ids: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'name': 'str',
        'address': 'common.v1.config.IPAddressOrFQDN',
        'credential': 'files.v4.config.Credential',
        'description': 'str',
        'should_discover_mount_targets': 'bool',
        'mount_target_ext_ids': 'list[str]',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'name': 'name',
        'address': 'address',
        'credential': 'credential',
        'description': 'description',
        'should_discover_mount_targets': 'shouldDiscoverMountTargets',
        'mount_target_ext_ids': 'mountTargetExtIds',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, name=None, address=None, credential=None, description=None, should_discover_mount_targets=False, mount_target_ext_ids=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__name = None
        self.__address = None
        self.__credential = None
        self.__description = None
        self.__should_discover_mount_targets = None
        self.__mount_target_ext_ids = None
        self.discriminator = None
        self.__name = name
        self.__address = address
        if credential is not None:
            self.__credential = credential
        if description is not None:
            self.__description = description
        if should_discover_mount_targets is not None:
            self.__should_discover_mount_targets = should_discover_mount_targets
        if mount_target_ext_ids is not None:
            self.__mount_target_ext_ids = mount_target_ext_ids

    def _initialize_object_type(self):
        return 'files.v4.config.MigrationSource'

    def _initialize_object_version(self):
        return 'v4.r0'


    @property
    def name(self):
        """
        Migration source name

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__name

    @name.setter
    def name(self, name):
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if name is not None and len(name) > 30:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `30`")  # noqa: E501
        if name is not None and len(name) < 1:
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self.__name = name

    @property
    def address(self):
        """
        

        :type:
            :class:`~ntnx_files_py_client.models.common.v1.config.IPAddressOrFQDN`
        """  # noqa: E501
        return self.__address

    @address.setter
    def address(self, address):
        if address is None:
            raise ValueError("Invalid value for `address`, must not be `None`")  # noqa: E501

        self.__address = address

    @property
    def credential(self):
        """
        

        :type:
            :class:`~ntnx_files_py_client.models.files.v4.config.Credential`
        """  # noqa: E501
        return self.__credential

    @credential.setter
    def credential(self, credential):

        self.__credential = credential

    @property
    def description(self):
        """
        Description for migration source

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__description

    @description.setter
    def description(self, description):
        if description is not None and len(description) > 120:
            raise ValueError("Invalid value for `description`, length must be less than or equal to `120`")  # noqa: E501

        self.__description = description

    @property
    def should_discover_mount_targets(self):
        """
        A flag to indicate if the backend should start mount-target discovery for migration source server. Upon completion of source creation task, list of discovered mount target can be fetched using GET mount-targets API on migration-sources. Note: Credential field is required for SMB mount-targets discovery and `shouldStartDiscoveryDesc` is write only field.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__should_discover_mount_targets

    @should_discover_mount_targets.setter
    def should_discover_mount_targets(self, should_discover_mount_targets):

        self.__should_discover_mount_targets = should_discover_mount_targets

    @property
    def mount_target_ext_ids(self):
        """
        List of mount target extIds for migration source server. This is a read-only field.

        :type:
            list[ :class:`~str` ]
        """  # noqa: E501
        return self.__mount_target_ext_ids

    @mount_target_ext_ids.setter
    def mount_target_ext_ids(self, mount_target_ext_ids):

        self.__mount_target_ext_ids = mount_target_ext_ids

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(MigrationSource, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MigrationSource):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

