# coding: utf-8


"""
IGNORE:
    Nutanix Files APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
import ntnx_files_py_client.models
from ntnx_files_py_client.models.OneOffiles.v4.config.ObjectStoreConfigconfiguration import ObjectStoreConfigconfiguration  # noqa: F401,E501
from ntnx_files_py_client.models.files.v4.config.ProxyServer import ProxyServer  # noqa: F401,E501

class ObjectStoreConfig(object):

    """Object store profile specification.

    :param base_url: (:attr:`base_url`) Base URL.
    :type base_url: required
    
    
    :param ca_cert_content: (:attr:`ca_cert_content`) CA certificate.
    :type ca_cert_content: 
    
    
    :param proxy_server: (:attr:`proxy_server`) 
    :type proxy_server: 
    
    
    :param configuration: (:attr:`configuration`) AWS/Azure configuration for tiering profile. User need to provide $objectType : files.v4.config.AWSConfig for AWS/NUTANIX object store type. For Azure object store type provide $objectType : files.v4.config.AzureConfig. 
    :type configuration: required
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'base_url': 'str',
        'ca_cert_content': 'str',
        'proxy_server': 'files.v4.config.ProxyServer',
        'configuration': 'OneOffiles.v4.config.ObjectStoreConfigconfiguration',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'base_url': 'baseUrl',
        'ca_cert_content': 'caCertContent',
        'proxy_server': 'proxyServer',
        'configuration': 'configuration',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, base_url=None, ca_cert_content=None, proxy_server=None, configuration=None, *args, **kwargs):  # noqa: E501
        self.__base_url = None
        self.__ca_cert_content = None
        self.__proxy_server = None
        self.__configuration = None
        self.discriminator = None
        self.__base_url = base_url
        if ca_cert_content is not None:
            self.__ca_cert_content = ca_cert_content
        if proxy_server is not None:
            self.__proxy_server = proxy_server
        self.__configuration = configuration
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'files.v4.config.ObjectStoreConfig'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def base_url(self):
        """
        Base URL.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__base_url

    @base_url.setter
    def base_url(self, base_url):
        if base_url is None:
            raise ValueError("Invalid value for `base_url`, must not be `None`")  # noqa: E501
        if base_url is not None and not re.search('^((http[s]?|nfs):\/)?\/?([^:\/\\s]*)((\/\\w+)*(:[0-9]+)*?\/)([\\w\\-\\.]+[^#?\\s]+)(.*)?(#[\\w\\-]+)?$', base_url):  # noqa: E501
            raise ValueError(r"Invalid value for `base_url`, must be a follow pattern or equal to `/^((http[s]?|nfs):\/)?\/?([^:\/\\s]*)((\/\\w+)*(:[0-9]+)*?\/)([\\w\\-\\.]+[^#?\\s]+)(.*)?(#[\\w\\-]+)?$/`")  # noqa: E501

        self.__base_url = base_url

    @property
    def ca_cert_content(self):
        """
        CA certificate.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__ca_cert_content

    @ca_cert_content.setter
    def ca_cert_content(self, ca_cert_content):

        self.__ca_cert_content = ca_cert_content

    @property
    def proxy_server(self):
        """
        

        :type:
            :class:`~ntnx_files_py_client.models.files.v4.config.ProxyServer`
        """  # noqa: E501
        return self.__proxy_server

    @proxy_server.setter
    def proxy_server(self, proxy_server):

        self.__proxy_server = proxy_server

    @property
    def configuration(self):
        """
        AWS/Azure configuration for tiering profile. User need to provide $objectType : files.v4.config.AWSConfig for AWS/NUTANIX object store type. For Azure object store type provide $objectType : files.v4.config.AzureConfig. 

        :type:
                :class:`~ntnx_files_py_client.models.files.v4.config.AWSConfig` | 
                :class:`~ntnx_files_py_client.models.files.v4.config.AzureConfig`
        """  # noqa: E501
        return self.__configuration

    @configuration.setter
    def configuration(self, configuration):
        if configuration is None:
            raise ValueError("Invalid value for `configuration`, must not be `None`")  # noqa: E501

        self.__configuration = configuration

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if attr_type.startswith('OneOf'):
                type = getattr(ntnx_files_py_client.models, attr_type.split('.')[-1])
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(ObjectStoreConfig, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ObjectStoreConfig):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

