# coding: utf-8


"""
IGNORE:
    Nutanix Files APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_files_py_client.models.files.v4.config.PermissionType import PermissionType  # noqa: F401,E501
from ntnx_files_py_client.models.files.v4.config.SMBAccessType import SMBAccessType  # noqa: F401,E501

class SMBShareACE(object):

    """Access control entry(ACE) for SMB share.

    :param user_or_group_name: (:attr:`user_or_group_name`) User or group name for share permission.
    :type user_or_group_name: required
     max=256 chars
    
    :param permission_type: (:attr:`permission_type`) 
    :type permission_type: required
    
    
    :param access_type: (:attr:`access_type`) 
    :type access_type: required
    
    
    :param sid: (:attr:`sid`) SID of user or group name. This is a read-only field.
    :type sid: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'user_or_group_name': 'str',
        'permission_type': 'files.v4.config.PermissionType',
        'access_type': 'files.v4.config.SMBAccessType',
        'sid': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'user_or_group_name': 'userOrGroupName',
        'permission_type': 'permissionType',
        'access_type': 'accessType',
        'sid': 'sid',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, user_or_group_name=None, permission_type=None, access_type=None, sid=None, *args, **kwargs):  # noqa: E501
        self.__user_or_group_name = None
        self.__permission_type = None
        self.__access_type = None
        self.__sid = None
        self.discriminator = None
        self.__user_or_group_name = user_or_group_name
        self.__permission_type = permission_type
        self.__access_type = access_type
        if sid is not None:
            self.__sid = sid
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'files.v4.config.SMBShareACE'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def user_or_group_name(self):
        """
        User or group name for share permission.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__user_or_group_name

    @user_or_group_name.setter
    def user_or_group_name(self, user_or_group_name):
        if user_or_group_name is None:
            raise ValueError("Invalid value for `user_or_group_name`, must not be `None`")  # noqa: E501
        if user_or_group_name is not None and len(user_or_group_name) > 256:
            raise ValueError("Invalid value for `user_or_group_name`, length must be less than or equal to `256`")  # noqa: E501

        self.__user_or_group_name = user_or_group_name

    @property
    def permission_type(self):
        """
        

        :type:
            :class:`~ntnx_files_py_client.models.files.v4.config.PermissionType`
        """  # noqa: E501
        return self.__permission_type

    @permission_type.setter
    def permission_type(self, permission_type):
        if permission_type is None:
            raise ValueError("Invalid value for `permission_type`, must not be `None`")  # noqa: E501

        self.__permission_type = permission_type

    @property
    def access_type(self):
        """
        

        :type:
            :class:`~ntnx_files_py_client.models.files.v4.config.SMBAccessType`
        """  # noqa: E501
        return self.__access_type

    @access_type.setter
    def access_type(self, access_type):
        if access_type is None:
            raise ValueError("Invalid value for `access_type`, must not be `None`")  # noqa: E501

        self.__access_type = access_type

    @property
    def sid(self):
        """
        SID of user or group name. This is a read-only field.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__sid

    @sid.setter
    def sid(self, sid):

        self.__sid = sid

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(SMBShareACE, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SMBShareACE):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

