# coding: utf-8


"""
IGNORE:
    Nutanix Files APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path

class ScheduleDetails(object):

    """Schedule for each day of week.

    :param start_hours: (:attr:`start_hours`) Start time hour of the schedule when tiering should start. For Ex. 15 (this means schedule will start at 3PM on that specific day.)
    :type start_hours: required
    
     min=0, max=24
    :param start_minutes: (:attr:`start_minutes`) Start time minute of the schedule.
    :type start_minutes: required
    
     min=0, max=59
    :param duration_minutes: (:attr:`duration_minutes`) The time difference between the start and the end time of schedule in minutes.
    :type duration_minutes: required
    
     min=0, max=1440

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'start_hours': 'int',
        'start_minutes': 'int',
        'duration_minutes': 'int',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'start_hours': 'startHours',
        'start_minutes': 'startMinutes',
        'duration_minutes': 'durationMinutes',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, start_hours=None, start_minutes=None, duration_minutes=None, *args, **kwargs):  # noqa: E501
        self.__start_hours = None
        self.__start_minutes = None
        self.__duration_minutes = None
        self.discriminator = None
        self.__start_hours = start_hours
        self.__start_minutes = start_minutes
        self.__duration_minutes = duration_minutes
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'files.v4.config.ScheduleDetails'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def start_hours(self):
        """
        Start time hour of the schedule when tiering should start. For Ex. 15 (this means schedule will start at 3PM on that specific day.)

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__start_hours

    @start_hours.setter
    def start_hours(self, start_hours):
        if start_hours is None:
            raise ValueError("Invalid value for `start_hours`, must not be `None`")  # noqa: E501
        if start_hours is not None and start_hours > 24:  # noqa: E501
            raise ValueError("Invalid value for `start_hours`, must be a value less than or equal to `24`")  # noqa: E501
        if start_hours is not None and start_hours < 0:  # noqa: E501
            raise ValueError("Invalid value for `start_hours`, must be a value greater than or equal to `0`")  # noqa: E501

        self.__start_hours = start_hours

    @property
    def start_minutes(self):
        """
        Start time minute of the schedule.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__start_minutes

    @start_minutes.setter
    def start_minutes(self, start_minutes):
        if start_minutes is None:
            raise ValueError("Invalid value for `start_minutes`, must not be `None`")  # noqa: E501
        if start_minutes is not None and start_minutes > 59:  # noqa: E501
            raise ValueError("Invalid value for `start_minutes`, must be a value less than or equal to `59`")  # noqa: E501
        if start_minutes is not None and start_minutes < 0:  # noqa: E501
            raise ValueError("Invalid value for `start_minutes`, must be a value greater than or equal to `0`")  # noqa: E501

        self.__start_minutes = start_minutes

    @property
    def duration_minutes(self):
        """
        The time difference between the start and the end time of schedule in minutes.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__duration_minutes

    @duration_minutes.setter
    def duration_minutes(self, duration_minutes):
        if duration_minutes is None:
            raise ValueError("Invalid value for `duration_minutes`, must not be `None`")  # noqa: E501
        if duration_minutes is not None and duration_minutes > 1440:  # noqa: E501
            raise ValueError("Invalid value for `duration_minutes`, must be a value less than or equal to `1440`")  # noqa: E501
        if duration_minutes is not None and duration_minutes < 0:  # noqa: E501
            raise ValueError("Invalid value for `duration_minutes`, must be a value greater than or equal to `0`")  # noqa: E501

        self.__duration_minutes = duration_minutes

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(ScheduleDetails, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ScheduleDetails):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

