# coding: utf-8


"""
IGNORE:
    Nutanix Files APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_files_py_client.models.files.v4.config.SMBShareACE import SMBShareACE  # noqa: F401,E501

class SmbProtocolProperties(object):

    """SMB protocol properties for mount target.

    :param is_access_based_enumeration_enabled: (:attr:`is_access_based_enumeration_enabled`) Flag to enable access based enumeration. (**Default** False)
    :type is_access_based_enumeration_enabled: 
    
    
    :param is_smb3_encryption_enabled: (:attr:`is_smb3_encryption_enabled`) Flag to enable SMB3 encryption. (**Default** False)
    :type is_smb3_encryption_enabled: 
    
    
    :param is_ca_enabled: (:attr:`is_ca_enabled`) Flag to enable continuous availability feature for SMB mount targets. (**Default** False)
    :type is_ca_enabled: 
    
    
    :param share_acl: (:attr:`share_acl`) Access control list(ACL) for SMB share.
    :type share_acl: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'is_access_based_enumeration_enabled': 'bool',
        'is_smb3_encryption_enabled': 'bool',
        'is_ca_enabled': 'bool',
        'share_acl': 'list[files.v4.config.SMBShareACE]',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'is_access_based_enumeration_enabled': 'isAccessBasedEnumerationEnabled',
        'is_smb3_encryption_enabled': 'isSmb3EncryptionEnabled',
        'is_ca_enabled': 'isCaEnabled',
        'share_acl': 'shareACL',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, is_access_based_enumeration_enabled=False, is_smb3_encryption_enabled=False, is_ca_enabled=False, share_acl=None, *args, **kwargs):  # noqa: E501
        self.__is_access_based_enumeration_enabled = None
        self.__is_smb3_encryption_enabled = None
        self.__is_ca_enabled = None
        self.__share_acl = None
        self.discriminator = None
        if is_access_based_enumeration_enabled is not None:
            self.__is_access_based_enumeration_enabled = is_access_based_enumeration_enabled
        if is_smb3_encryption_enabled is not None:
            self.__is_smb3_encryption_enabled = is_smb3_encryption_enabled
        if is_ca_enabled is not None:
            self.__is_ca_enabled = is_ca_enabled
        if share_acl is not None:
            self.__share_acl = share_acl
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'files.v4.config.SmbProtocolProperties'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def is_access_based_enumeration_enabled(self):
        """
        Flag to enable access based enumeration.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_access_based_enumeration_enabled

    @is_access_based_enumeration_enabled.setter
    def is_access_based_enumeration_enabled(self, is_access_based_enumeration_enabled):

        self.__is_access_based_enumeration_enabled = is_access_based_enumeration_enabled

    @property
    def is_smb3_encryption_enabled(self):
        """
        Flag to enable SMB3 encryption.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_smb3_encryption_enabled

    @is_smb3_encryption_enabled.setter
    def is_smb3_encryption_enabled(self, is_smb3_encryption_enabled):

        self.__is_smb3_encryption_enabled = is_smb3_encryption_enabled

    @property
    def is_ca_enabled(self):
        """
        Flag to enable continuous availability feature for SMB mount targets.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_ca_enabled

    @is_ca_enabled.setter
    def is_ca_enabled(self, is_ca_enabled):

        self.__is_ca_enabled = is_ca_enabled

    @property
    def share_acl(self):
        """
        Access control list(ACL) for SMB share.

        :type:
             list[ :class:`~ntnx_files_py_client.models.files.v4.config.SMBShareACE` ]
        """  # noqa: E501
        return self.__share_acl

    @share_acl.setter
    def share_acl(self, share_acl):

        self.__share_acl = share_acl

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(SmbProtocolProperties, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SmbProtocolProperties):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

