# coding: utf-8


"""
IGNORE:
    Nutanix Files APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_files_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_files_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501
from ntnx_files_py_client.models.files.v4.config.ChangedContent import ChangedContent  # noqa: F401,E501

class SnapshotChangedContent(ExternalizableAbstractModel):

    """Snapshot change content details.

    :param snapshot_ext_id: (:attr:`snapshot_ext_id`) Current snapshot associated with changed files metdata.
    :type snapshot_ext_id: required
    
    
    :param base_snapshot_ext_id: (:attr:`base_snapshot_ext_id`) Reference snapshot associated with changed files metdata.
    :type base_snapshot_ext_id: 
    
    
    :param changed_contents: (:attr:`changed_contents`) List of changed content. This is a read-only field.
    :type changed_contents: 
    
    
    :param has_more_content: (:attr:`has_more_content`) If this is set to false, this is the last page of the output. This is a read-only field.
    :type has_more_content: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'snapshot_ext_id': 'str',
        'base_snapshot_ext_id': 'str',
        'changed_contents': 'list[files.v4.config.ChangedContent]',
        'has_more_content': 'bool',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'snapshot_ext_id': 'snapshotExtId',
        'base_snapshot_ext_id': 'baseSnapshotExtId',
        'changed_contents': 'changedContents',
        'has_more_content': 'hasMoreContent',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, snapshot_ext_id=None, base_snapshot_ext_id=None, changed_contents=None, has_more_content=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__snapshot_ext_id = None
        self.__base_snapshot_ext_id = None
        self.__changed_contents = None
        self.__has_more_content = None
        self.discriminator = None
        self.__snapshot_ext_id = snapshot_ext_id
        if base_snapshot_ext_id is not None:
            self.__base_snapshot_ext_id = base_snapshot_ext_id
        if changed_contents is not None:
            self.__changed_contents = changed_contents
        if has_more_content is not None:
            self.__has_more_content = has_more_content

    def _initialize_object_type(self):
        return 'files.v4.config.SnapshotChangedContent'

    def _initialize_object_version(self):
        return 'v4.r0'


    @property
    def snapshot_ext_id(self):
        """
        Current snapshot associated with changed files metdata.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__snapshot_ext_id

    @snapshot_ext_id.setter
    def snapshot_ext_id(self, snapshot_ext_id):
        if snapshot_ext_id is None:
            raise ValueError("Invalid value for `snapshot_ext_id`, must not be `None`")  # noqa: E501
        if snapshot_ext_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', snapshot_ext_id):  # noqa: E501
            raise ValueError(r"Invalid value for `snapshot_ext_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__snapshot_ext_id = snapshot_ext_id

    @property
    def base_snapshot_ext_id(self):
        """
        Reference snapshot associated with changed files metdata.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__base_snapshot_ext_id

    @base_snapshot_ext_id.setter
    def base_snapshot_ext_id(self, base_snapshot_ext_id):
        if base_snapshot_ext_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', base_snapshot_ext_id):  # noqa: E501
            raise ValueError(r"Invalid value for `base_snapshot_ext_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__base_snapshot_ext_id = base_snapshot_ext_id

    @property
    def changed_contents(self):
        """
        List of changed content. This is a read-only field.

        :type:
             list[ :class:`~ntnx_files_py_client.models.files.v4.config.ChangedContent` ]
        """  # noqa: E501
        return self.__changed_contents

    @changed_contents.setter
    def changed_contents(self, changed_contents):

        self.__changed_contents = changed_contents

    @property
    def has_more_content(self):
        """
        If this is set to false, this is the last page of the output. This is a read-only field.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__has_more_content

    @has_more_content.setter
    def has_more_content(self, has_more_content):

        self.__has_more_content = has_more_content

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(SnapshotChangedContent, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SnapshotChangedContent):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

