# coding: utf-8


"""
IGNORE:
    Nutanix Files APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_files_py_client.models.files.v4.config.LoginStatus import LoginStatus  # noqa: F401,E501

class VDIUserLoginEventLog(object):

    """VDI synchronization event contains detailed user information. For example - login details like login and logoff time, login status, and more.

    :param file_server_ext_id: (:attr:`file_server_ext_id`) External identifier of the file server that user attempted to login.
    :type file_server_ext_id: 
    
    
    :param login_time: (:attr:`login_time`) VDI synchronization user login time in ISO format. This is a read-only field.
    :type login_time: 
    
    
    :param logout_time: (:attr:`logout_time`) VDI synchronization user logoff time in ISO format. This is a read-only field.
    :type logout_time: 
    
    
    :param status: (:attr:`status`) 
    :type status: 
    
    
    :param failure_reason: (:attr:`failure_reason`) The reason why the user cannot login and is considered impacted. This may be due to unsynchronized data, user name conflicts, or if the user is active on other sites.
    :type failure_reason: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'file_server_ext_id': 'str',
        'login_time': 'datetime',
        'logout_time': 'datetime',
        'status': 'files.v4.config.LoginStatus',
        'failure_reason': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'file_server_ext_id': 'fileServerExtId',
        'login_time': 'loginTime',
        'logout_time': 'logoutTime',
        'status': 'status',
        'failure_reason': 'failureReason',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, file_server_ext_id=None, login_time=None, logout_time=None, status=None, failure_reason=None, *args, **kwargs):  # noqa: E501
        self.__file_server_ext_id = None
        self.__login_time = None
        self.__logout_time = None
        self.__status = None
        self.__failure_reason = None
        self.discriminator = None
        if file_server_ext_id is not None:
            self.__file_server_ext_id = file_server_ext_id
        if login_time is not None:
            self.__login_time = login_time
        if logout_time is not None:
            self.__logout_time = logout_time
        if status is not None:
            self.__status = status
        if failure_reason is not None:
            self.__failure_reason = failure_reason
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'files.v4.config.VDIUserLoginEventLog'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def file_server_ext_id(self):
        """
        External identifier of the file server that user attempted to login.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__file_server_ext_id

    @file_server_ext_id.setter
    def file_server_ext_id(self, file_server_ext_id):
        if file_server_ext_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', file_server_ext_id):  # noqa: E501
            raise ValueError(r"Invalid value for `file_server_ext_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__file_server_ext_id = file_server_ext_id

    @property
    def login_time(self):
        """
        VDI synchronization user login time in ISO format. This is a read-only field.

        :type:
                :class:`~datetime`
        """  # noqa: E501
        return self.__login_time

    @login_time.setter
    def login_time(self, login_time):

        self.__login_time = login_time

    @property
    def logout_time(self):
        """
        VDI synchronization user logoff time in ISO format. This is a read-only field.

        :type:
                :class:`~datetime`
        """  # noqa: E501
        return self.__logout_time

    @logout_time.setter
    def logout_time(self, logout_time):

        self.__logout_time = logout_time

    @property
    def status(self):
        """
        

        :type:
            :class:`~ntnx_files_py_client.models.files.v4.config.LoginStatus`
        """  # noqa: E501
        return self.__status

    @status.setter
    def status(self, status):

        self.__status = status

    @property
    def failure_reason(self):
        """
        The reason why the user cannot login and is considered impacted. This may be due to unsynchronized data, user name conflicts, or if the user is active on other sites.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__failure_reason

    @failure_reason.setter
    def failure_reason(self, failure_reason):

        self.__failure_reason = failure_reason

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(VDIUserLoginEventLog, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VDIUserLoginEventLog):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

