# coding: utf-8


"""
IGNORE:
    Nutanix Files APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_files_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_files_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501
from ntnx_files_py_client.models.files.v4.config.VDIUserLoginEventLog import VDIUserLoginEventLog  # noqa: F401,E501

class VdiUserSession(ExternalizableAbstractModel):

    """A VDI session for the user that tried to login.

    :param user_name: (:attr:`user_name`) Domain and username of the user. Internally it is converted to user SID. This is a read-only field.
    :type user_name: 
     min=1 chars, max=256 chars
    
    :param owner_file_server_ext_id: (:attr:`owner_file_server_ext_id`) File server external identifier that is or will become the owner file server for the specified users depending on the action performed.
    :type owner_file_server_ext_id: required
    
    
    :param current_session: (:attr:`current_session`) 
    :type current_session: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'user_name': 'str',
        'owner_file_server_ext_id': 'str',
        'current_session': 'files.v4.config.VDIUserLoginEventLog',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'user_name': 'userName',
        'owner_file_server_ext_id': 'ownerFileServerExtId',
        'current_session': 'currentSession',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, user_name=None, owner_file_server_ext_id=None, current_session=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__user_name = None
        self.__owner_file_server_ext_id = None
        self.__current_session = None
        self.discriminator = None
        if user_name is not None:
            self.__user_name = user_name
        self.__owner_file_server_ext_id = owner_file_server_ext_id
        if current_session is not None:
            self.__current_session = current_session

    def _initialize_object_type(self):
        return 'files.v4.config.VdiUserSession'

    def _initialize_object_version(self):
        return 'v4.r0'


    @property
    def user_name(self):
        """
        Domain and username of the user. Internally it is converted to user SID. This is a read-only field.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__user_name

    @user_name.setter
    def user_name(self, user_name):
        if user_name is not None and len(user_name) > 256:
            raise ValueError("Invalid value for `user_name`, length must be less than or equal to `256`")  # noqa: E501
        if user_name is not None and len(user_name) < 1:
            raise ValueError("Invalid value for `user_name`, length must be greater than or equal to `1`")  # noqa: E501

        self.__user_name = user_name

    @property
    def owner_file_server_ext_id(self):
        """
        File server external identifier that is or will become the owner file server for the specified users depending on the action performed.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__owner_file_server_ext_id

    @owner_file_server_ext_id.setter
    def owner_file_server_ext_id(self, owner_file_server_ext_id):
        if owner_file_server_ext_id is None:
            raise ValueError("Invalid value for `owner_file_server_ext_id`, must not be `None`")  # noqa: E501
        if owner_file_server_ext_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', owner_file_server_ext_id):  # noqa: E501
            raise ValueError(r"Invalid value for `owner_file_server_ext_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__owner_file_server_ext_id = owner_file_server_ext_id

    @property
    def current_session(self):
        """
        

        :type:
            :class:`~ntnx_files_py_client.models.files.v4.config.VDIUserLoginEventLog`
        """  # noqa: E501
        return self.__current_session

    @current_session.setter
    def current_session(self, current_session):

        self.__current_session = current_session

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(VdiUserSession, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VdiUserSession):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

