# coding: utf-8


"""
IGNORE:
    Nutanix Files APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_files_py_client.models.common.v1.config.IPAddressOrFQDN import IPAddressOrFQDN  # noqa: F401,E501
from ntnx_files_py_client.models.common.v1.config.KVStringPair import KVStringPair  # noqa: F401,E501
from ntnx_files_py_client.models.files.v4.config.ConnectionStatus import ConnectionStatus  # noqa: F401,E501
from ntnx_files_py_client.models.files.v4.config.ServerType import ServerType  # noqa: F401,E501

class VendorProperties(object):

    """Partner server configuration for the following types of servers ```   - BACKUP   - MIGRATION   - NOTIFICATION ``` 

    :param custom_properties: (:attr:`custom_properties`) Indicates the vendor specific custom properties of the partner server. It contains key value pairs separated by pipe(|)operator. For example: kafkatopic=1P1R| brokerlist=10.5.119.71:29092,10.5.119.71:39092,10.5.119.71:49092
    :type custom_properties: 
    
    
    :param connection_status: (:attr:`connection_status`) 
    :type connection_status: 
    
    
    :param address: (:attr:`address`) 
    :type address: required
    
    
    :param port: (:attr:`port`) Partner server port.
    :type port: required
    
     min=1, max=65536
    :param server_type: (:attr:`server_type`) 
    :type server_type: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'custom_properties': 'list[common.v1.config.KVStringPair]',
        'connection_status': 'files.v4.config.ConnectionStatus',
        'address': 'common.v1.config.IPAddressOrFQDN',
        'port': 'int',
        'server_type': 'files.v4.config.ServerType',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'custom_properties': 'customProperties',
        'connection_status': 'connectionStatus',
        'address': 'address',
        'port': 'port',
        'server_type': 'serverType',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, custom_properties=None, connection_status=None, address=None, port=None, server_type=None, *args, **kwargs):  # noqa: E501
        self.__custom_properties = None
        self.__connection_status = None
        self.__address = None
        self.__port = None
        self.__server_type = None
        self.discriminator = None
        if custom_properties is not None:
            self.__custom_properties = custom_properties
        if connection_status is not None:
            self.__connection_status = connection_status
        self.__address = address
        self.__port = port
        if server_type is not None:
            self.__server_type = server_type
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'files.v4.config.VendorProperties'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def custom_properties(self):
        """
        Indicates the vendor specific custom properties of the partner server. It contains key value pairs separated by pipe(|)operator. For example: kafkatopic=1P1R| brokerlist=10.5.119.71:29092,10.5.119.71:39092,10.5.119.71:49092

        :type:
             list[ :class:`~ntnx_files_py_client.models.common.v1.config.KVStringPair` ]
        """  # noqa: E501
        return self.__custom_properties

    @custom_properties.setter
    def custom_properties(self, custom_properties):

        self.__custom_properties = custom_properties

    @property
    def connection_status(self):
        """
        

        :type:
            :class:`~ntnx_files_py_client.models.files.v4.config.ConnectionStatus`
        """  # noqa: E501
        return self.__connection_status

    @connection_status.setter
    def connection_status(self, connection_status):

        self.__connection_status = connection_status

    @property
    def address(self):
        """
        

        :type:
            :class:`~ntnx_files_py_client.models.common.v1.config.IPAddressOrFQDN`
        """  # noqa: E501
        return self.__address

    @address.setter
    def address(self, address):
        if address is None:
            raise ValueError("Invalid value for `address`, must not be `None`")  # noqa: E501

        self.__address = address

    @property
    def port(self):
        """
        Partner server port.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__port

    @port.setter
    def port(self, port):
        if port is None:
            raise ValueError("Invalid value for `port`, must not be `None`")  # noqa: E501
        if port is not None and port > 65536:  # noqa: E501
            raise ValueError("Invalid value for `port`, must be a value less than or equal to `65536`")  # noqa: E501
        if port is not None and port < 1:  # noqa: E501
            raise ValueError("Invalid value for `port`, must be a value greater than or equal to `1`")  # noqa: E501

        self.__port = port

    @property
    def server_type(self):
        """
        

        :type:
            :class:`~ntnx_files_py_client.models.files.v4.config.ServerType`
        """  # noqa: E501
        return self.__server_type

    @server_type.setter
    def server_type(self, server_type):

        self.__server_type = server_type

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(VendorProperties, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VendorProperties):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

