# coding: utf-8


"""
IGNORE:
    Nutanix Files APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_files_py_client.models.files.v4.config.WormType import WormType  # noqa: F401,E501

class WormSpec(object):

    """WORM share details.

    :param worm_type: (:attr:`worm_type`) 
    :type worm_type: 
    
    
    :param cooloff_interval_seconds: (:attr:`cooloff_interval_seconds`) Cooloff interval in seconds for WORM share. (**Default** 600)
    :type cooloff_interval_seconds: 
    
    
    :param retention_period_seconds: (:attr:`retention_period_seconds`) Retention period in seconds for WORM share. (**Default** 31449600)
    :type retention_period_seconds: 
    
    
    :param is_compliance_enabled: (:attr:`is_compliance_enabled`) WORM compliance for share. This is a read-only field. (**Default** False)
    :type is_compliance_enabled: 
    
    
    :param is_legal_hold_enabled: (:attr:`is_legal_hold_enabled`) Legal hold for WORM share. This is a read-only field. (**Default** False)
    :type is_legal_hold_enabled: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'worm_type': 'files.v4.config.WormType',
        'cooloff_interval_seconds': 'int',
        'retention_period_seconds': 'int',
        'is_compliance_enabled': 'bool',
        'is_legal_hold_enabled': 'bool',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'worm_type': 'wormType',
        'cooloff_interval_seconds': 'cooloffIntervalSeconds',
        'retention_period_seconds': 'retentionPeriodSeconds',
        'is_compliance_enabled': 'isComplianceEnabled',
        'is_legal_hold_enabled': 'isLegalHoldEnabled',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, worm_type=None, cooloff_interval_seconds=600, retention_period_seconds=31449600, is_compliance_enabled=False, is_legal_hold_enabled=False, *args, **kwargs):  # noqa: E501
        self.__worm_type = None
        self.__cooloff_interval_seconds = None
        self.__retention_period_seconds = None
        self.__is_compliance_enabled = None
        self.__is_legal_hold_enabled = None
        self.discriminator = None
        if worm_type is not None:
            self.__worm_type = worm_type
        if cooloff_interval_seconds is not None:
            self.__cooloff_interval_seconds = cooloff_interval_seconds
        if retention_period_seconds is not None:
            self.__retention_period_seconds = retention_period_seconds
        if is_compliance_enabled is not None:
            self.__is_compliance_enabled = is_compliance_enabled
        if is_legal_hold_enabled is not None:
            self.__is_legal_hold_enabled = is_legal_hold_enabled
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'files.v4.config.WormSpec'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def worm_type(self):
        """
        

        :type:
            :class:`~ntnx_files_py_client.models.files.v4.config.WormType`
        """  # noqa: E501
        return self.__worm_type

    @worm_type.setter
    def worm_type(self, worm_type):

        self.__worm_type = worm_type

    @property
    def cooloff_interval_seconds(self):
        """
        Cooloff interval in seconds for WORM share.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__cooloff_interval_seconds

    @cooloff_interval_seconds.setter
    def cooloff_interval_seconds(self, cooloff_interval_seconds):

        self.__cooloff_interval_seconds = cooloff_interval_seconds

    @property
    def retention_period_seconds(self):
        """
        Retention period in seconds for WORM share.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__retention_period_seconds

    @retention_period_seconds.setter
    def retention_period_seconds(self, retention_period_seconds):

        self.__retention_period_seconds = retention_period_seconds

    @property
    def is_compliance_enabled(self):
        """
        WORM compliance for share. This is a read-only field.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_compliance_enabled

    @is_compliance_enabled.setter
    def is_compliance_enabled(self, is_compliance_enabled):

        self.__is_compliance_enabled = is_compliance_enabled

    @property
    def is_legal_hold_enabled(self):
        """
        Legal hold for WORM share. This is a read-only field.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_legal_hold_enabled

    @is_legal_hold_enabled.setter
    def is_legal_hold_enabled(self, is_legal_hold_enabled):

        self.__is_legal_hold_enabled = is_legal_hold_enabled

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(WormSpec, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, WormSpec):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

