# coding: utf-8


"""
IGNORE:
    Nutanix Files APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_files_py_client.models.files.v4.config.DnsRecordSpec import DnsRecordSpec  # noqa: F401,E501
from ntnx_files_py_client.models.files.v4.operations.ADServerSpec import ADServerSpec  # noqa: F401,E501
from ntnx_files_py_client.models.files.v4.operations.FailoverType import FailoverType  # noqa: F401,E501

class FailoverSpec(object):

    """Failover model.

    :param primary_file_server_ext_id: (:attr:`primary_file_server_ext_id`) The external identifier of the primary file server for the replication.
    :type primary_file_server_ext_id: required
    
    
    :param secondary_file_server_ext_id: (:attr:`secondary_file_server_ext_id`) The external identifier of the secondary file server for the replication.
    :type secondary_file_server_ext_id: required
    
    
    :param active_directory: (:attr:`active_directory`) 
    :type active_directory: 
    
    
    :param dns: (:attr:`dns`) 
    :type dns: 
    
    
    :param type: (:attr:`type`) 
    :type type: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'primary_file_server_ext_id': 'str',
        'secondary_file_server_ext_id': 'str',
        'active_directory': 'files.v4.operations.ADServerSpec',
        'dns': 'files.v4.config.DnsRecordSpec',
        'type': 'files.v4.operations.FailoverType',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'primary_file_server_ext_id': 'primaryFileServerExtId',
        'secondary_file_server_ext_id': 'secondaryFileServerExtId',
        'active_directory': 'activeDirectory',
        'dns': 'dns',
        'type': 'type',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, primary_file_server_ext_id=None, secondary_file_server_ext_id=None, active_directory=None, dns=None, type=None, *args, **kwargs):  # noqa: E501
        self.__primary_file_server_ext_id = None
        self.__secondary_file_server_ext_id = None
        self.__active_directory = None
        self.__dns = None
        self.__type = None
        self.discriminator = None
        self.__primary_file_server_ext_id = primary_file_server_ext_id
        self.__secondary_file_server_ext_id = secondary_file_server_ext_id
        if active_directory is not None:
            self.__active_directory = active_directory
        if dns is not None:
            self.__dns = dns
        if type is not None:
            self.__type = type
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'files.v4.operations.FailoverSpec'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def primary_file_server_ext_id(self):
        """
        The external identifier of the primary file server for the replication.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__primary_file_server_ext_id

    @primary_file_server_ext_id.setter
    def primary_file_server_ext_id(self, primary_file_server_ext_id):
        if primary_file_server_ext_id is None:
            raise ValueError("Invalid value for `primary_file_server_ext_id`, must not be `None`")  # noqa: E501
        if primary_file_server_ext_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', primary_file_server_ext_id):  # noqa: E501
            raise ValueError(r"Invalid value for `primary_file_server_ext_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__primary_file_server_ext_id = primary_file_server_ext_id

    @property
    def secondary_file_server_ext_id(self):
        """
        The external identifier of the secondary file server for the replication.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__secondary_file_server_ext_id

    @secondary_file_server_ext_id.setter
    def secondary_file_server_ext_id(self, secondary_file_server_ext_id):
        if secondary_file_server_ext_id is None:
            raise ValueError("Invalid value for `secondary_file_server_ext_id`, must not be `None`")  # noqa: E501
        if secondary_file_server_ext_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', secondary_file_server_ext_id):  # noqa: E501
            raise ValueError(r"Invalid value for `secondary_file_server_ext_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__secondary_file_server_ext_id = secondary_file_server_ext_id

    @property
    def active_directory(self):
        """
        

        :type:
            :class:`~ntnx_files_py_client.models.files.v4.operations.ADServerSpec`
        """  # noqa: E501
        return self.__active_directory

    @active_directory.setter
    def active_directory(self, active_directory):

        self.__active_directory = active_directory

    @property
    def dns(self):
        """
        

        :type:
            :class:`~ntnx_files_py_client.models.files.v4.config.DnsRecordSpec`
        """  # noqa: E501
        return self.__dns

    @dns.setter
    def dns(self, dns):

        self.__dns = dns

    @property
    def type(self):
        """
        

        :type:
            :class:`~ntnx_files_py_client.models.files.v4.operations.FailoverType`
        """  # noqa: E501
        return self.__type

    @type.setter
    def type(self, type):

        self.__type = type

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(FailoverSpec, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FailoverSpec):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

