# coding: utf-8


"""
IGNORE:
    Nutanix Files APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_files_py_client.models.files.v4.config.DnsRecordSpec import DnsRecordSpec  # noqa: F401,E501
from ntnx_files_py_client.models.files.v4.operations.ADServerSpec import ADServerSpec  # noqa: F401,E501
from ntnx_files_py_client.models.files.v4.operations.FailoverSpec import FailoverSpec  # noqa: F401,E501
from ntnx_files_py_client.models.files.v4.operations.FailoverType import FailoverType  # noqa: F401,E501
from ntnx_files_py_client.models.files.v4.operations.ReplicationDirection import ReplicationDirection  # noqa: F401,E501

class ResumeReplicationSpec(FailoverSpec):

    """This contains the parameters to resume mount target level replication after performing failover.

    :param replication_direction: (:attr:`replication_direction`) 
    :type replication_direction: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'replication_direction': 'files.v4.operations.ReplicationDirection',
        'primary_file_server_ext_id': 'str',
        'secondary_file_server_ext_id': 'str',
        'active_directory': 'files.v4.operations.ADServerSpec',
        'dns': 'files.v4.config.DnsRecordSpec',
        'type': 'files.v4.operations.FailoverType',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'replication_direction': 'replicationDirection',
        'primary_file_server_ext_id': 'primaryFileServerExtId',
        'secondary_file_server_ext_id': 'secondaryFileServerExtId',
        'active_directory': 'activeDirectory',
        'dns': 'dns',
        'type': 'type',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, replication_direction=None, primary_file_server_ext_id=None, secondary_file_server_ext_id=None, active_directory=None, dns=None, type=None, *args, **kwargs):  # noqa: E501
        FailoverSpec.__init__(self, primary_file_server_ext_id, secondary_file_server_ext_id, active_directory, dns, type, *args, **kwargs)
        self.__replication_direction = None
        self.discriminator = None
        if replication_direction is not None:
            self.__replication_direction = replication_direction

    def _initialize_object_type(self):
        return 'files.v4.operations.ResumeReplicationSpec'

    def _initialize_object_version(self):
        return 'v4.r0'


    @property
    def replication_direction(self):
        """
        

        :type:
            :class:`~ntnx_files_py_client.models.files.v4.operations.ReplicationDirection`
        """  # noqa: E501
        return self.__replication_direction

    @replication_direction.setter
    def replication_direction(self, replication_direction):

        self.__replication_direction = replication_direction

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(ResumeReplicationSpec, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ResumeReplicationSpec):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

